/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import net.designnation.data.*
import net.designnation.events.*

class net.designnation.events.IEventRegisterImpl implements IEventRegister
{
	private var table: HashMap;
	public var __traceInfo__: Boolean= false;
	
	public function IEventRegisterImpl(  )
	{
		this.table= new HashMap(  );
	}
	
	public function registerEvent( obj: Object, eventName: String, eventCallbackName: String ): Boolean
	{
		var list: List= List( table.getItem( eventName ) );		
		var retVal: Boolean= false;
		
		var eventData: Object= { source: obj, eventCallbackName: eventCallbackName };
		
		if( list== undefined )
		{
			list= new List( ObjectKeyComparator.OBJECT_KEY_COMPARATOR );
			
			list.push( eventData );			
			retVal= table.setItem( eventName, list );
		}
		else
		{
			retVal= list.push( eventData );
		}		
		return retVal;
	}
	
	public function unregisterEvent( obj: Object, eventName: String ): Boolean
	{
		var list: List= List( table.getItem( eventName ) );		
		var retVal: Boolean= false;
		
		if( list!= undefined )
		{
			retVal= list.deleteElement( obj );						
		}						
		return retVal;
	}
	
	public function fireEvent( eventName: String, arg: Object ): HashMap
	{
		var eventList: List= List( table.getItem( eventName ) );
		
		var it: IIterator= eventList.iterator(  );
		
		var retVal: HashMap= new HashMap(  );
		
		if( it!= undefined )
		{
			var obj: Object;
			
			while( it.hasNext(  ) )
			{
				obj= it.next(  );
				// Fire and store the result!!!
				//												
				var eventCallbackName: String= obj.eventCallbackName!= undefined? obj.eventCallbackName: eventName;
				
				var eventRetVal: Object= obj.source[ eventCallbackName ]( arg );
				
				if( eventRetVal!= undefined )
				{
					retVal.setItem( obj.source, eventRetVal );
				}
			}
		}	
		return retVal;		
	}
	
	public function clearRegisteredEvents(  )
	{
		this.table= new HashMap(  );
	}
}


